<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryRef"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="模板名称" prop="title">
        <el-input
          v-model="queryParams.title"
          placeholder="请输入模板名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="模板类型" prop="type">
        <el-select
          v-model="queryParams.type"
          placeholder="请选择模板类型"
          clearable
          style="width: 150px"
        >
          <el-option
            v-for="type in templateTypeList"
            :key="type.id"
            :label="type.title"
            :value="type.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="行业" prop="industry">
        <el-input
          v-model="queryParams.industry"
          placeholder="请输入行业"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <!-- <el-form-item label="用户账号" prop="phone">
                <el-input
                    v-model="queryParams.phone"
                    placeholder="请输入用户账号"
                    clearable
                    @keyup.enter="handleQuery"
                />
            </el-form-item> -->
      <el-form-item label="浏览量" prop="viewCount">
        <el-input
          v-model="queryParams.viewCount"
          placeholder="请输入浏览量"
          clearable
          @keyup.enter="handleQuery"
        /> </el-form-item
      ><el-form-item label="状态" prop="status">
        <el-select
          v-model="queryParams.status"
          placeholder="请选择状态"
          clearable
          style="width: 150px"
        >
          <el-option
            v-for="type in statusTypeList"
            :key="type.id"
            :label="type.title"
            :value="type.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['vrone:template:add']"
          >新增</el-button
        >
      </el-col>
      <right-toolbar
        v-model:showSearch="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="templateList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="id" align="center" prop="id" /> -->
      <el-table-column label="模板名称" align="center" prop="title" />
      <el-table-column label="模板类型" align="center" prop="type">
        <template #default="scope">
          {{
            templateTypeList.find((type) => type.id === scope.row.type)
              ?.title || "未知类型"
          }}
        </template>
      </el-table-column>
      <el-table-column label="模板链接" align="center" prop="url" />
      <el-table-column label="模板图片" align="center" prop="imgUrl">
        <template #default="scope">
          <image-preview :src="scope.row.imgUrl" :width="50" :height="50" />
        </template>
      </el-table-column>
      <el-table-column label="模板简介" align="center" prop="introduction" />
      <el-table-column label="价格" align="center" prop="price" />
      <el-table-column label="行业" align="center" prop="industry" />
      <!-- <el-table-column label="创建用户账号" align="center" prop="phone" /> -->
      <el-table-column label="浏览量" align="center" prop="viewCount" />
      <el-table-column label="状态" align="center" prop="status">
        <template #default="scope">
          {{
            statusTypeList.find((type) => type.id === scope.row.status)
              ?.title || "未知状态"
          }}
        </template>
      </el-table-column>
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template #default="scope">
          <el-button
            link
            type="primary"
            icon="Edit"
            @click="handleUpdate(scope.row)"
            >修改</el-button
          >
          <el-button
            link
            type="primary"
            icon="Delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['vrone:template:remove']"
          >
            删除
          </el-button>
          <!-- <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['vrone:template:remove']">删除</el-button> -->
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改模板对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form
        ref="templateRef"
        :model="form"
        :rules="rules"
        label-width="80px"
      >
        <el-form-item label="模板名称" prop="title">
          <el-input v-model="form.title" placeholder="请输入模板名称" />
        </el-form-item>
        <el-form-item label="模板类型" prop="type" v-if="title === '添加模板'">
          <el-select
            v-model="form.type"
            placeholder="请选择模板类型"
            clearable
            style="width: 150px"
          >
            <el-option
              v-for="type in templateTypeList"
              :key="type.id"
              :label="type.title"
              :value="type.id"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="模板链接" prop="url" v-if="title === '添加模板'">
          <el-input v-model="form.url" placeholder="请输入模板链接" />
        </el-form-item>
        <el-form-item label="模板图片" prop="imgUrl">
          <image-upload v-model="form.imgUrl" />
        </el-form-item>
        <el-form-item label="模板简介" prop="introduction">
          <el-input
            v-model="form.introduction"
            placeholder="请输入模板简介"
            type="textarea"
          />
        </el-form-item>
        <el-form-item label="模板正文" prop="text">
          <editor v-model="form.text" :min-height="192" />
        </el-form-item>
        <el-form-item label="价格" prop="price" v-if="title === '添加模板'">
          <el-input v-model="form.price" placeholder="请输入价格" />
        </el-form-item>
        <el-form-item label="行业" prop="industry">
          <el-input v-model="form.industry" placeholder="请输入行业" />
        </el-form-item>
        <el-form-item label="状态" prop="status" v-if="title === '修改模板'">
          <el-select
            v-model="form.status"
            placeholder="请选择状态"
            clearable
            style="width: 150px"
          >
            <el-option
              v-for="type in statusTypeList"
              :key="type.id"
              :label="type.title"
              :value="type.id"
            />
          </el-select>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Template">
import {
  listTemplate,
  getTemplate,
  delTemplate,
  addTemplate,
  updateTemplate,
} from "@/api/vrone/template";

const { proxy } = getCurrentInstance();

const templateList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const templateTypeList = ref([
  {
    id: 2,
    title: "720",
  },
  {
    id: 1,
    title: "unity",
  },
]);
const statusTypeList = ref([
  {
    id: 2,
    title: "打回",
  },
  {
    id: 1,
    title: "展示",
  },
  {
    id: 0,
    title: "审核",
  },
  {
    id: -1,
    title: "不展示",
  },
]);
const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    title: null,
    type: null,
    url: null,
    introduction: null,
    industry: null,
    userId: null,
    viewCount: null,
    status: null,
  },
  rules: {},
});

const { queryParams, form, rules } = toRefs(data);

/** 查询模板列表 */
function getList() {
  loading.value = true;
  listTemplate(queryParams.value).then((response) => {
    templateList.value = response.data;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    title: null,
    type: null,
    url: null,
    img_url: null,
    introduction: null,
    text: null,
    price: null,
    industry: null,
    userId: null,
    viewCount: null,
    status: null,
    createTime: null,
    updateTime: null,
  };
  proxy.resetForm("templateRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加模板";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _id = row.id || ids.value;
  getTemplate(_id).then((response) => {
    form.value = response.data;
    open.value = true;
    title.value = "修改模板";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["templateRef"].validate((valid) => {
    if (valid) {
      if (form.value.id != null) {
        updateTemplate(form.value).then((response) => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addTemplate(form.value).then((response) => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除展厅模板操作 */
function handleDelete(row) {
  const templateIds = row?.id ? [row.id] : ids.value;
  if (!templateIds.length) return;

  proxy.$modal
    .confirm(`是否确认删除选中的展厅模板？`)
    .then(() => {
      return delTemplate(templateIds.join(","));
    })
    .then(() => {
      proxy.$modal.msgSuccess("删除成功");
      getList();
      ids.value = []; // ✅ 清空选中项
      multiple.value = true;
    })
    .catch(() => {});
}

getList();
</script>
